/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JPanel.java to edit this template
 */
package StoreManagement;

import Service.StoreService;
import java.awt.Font;
import java.awt.Image;
import java.text.MessageFormat;
import java.util.List;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.UIManager;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableModel;
import model.Store;

/**
 *
 * @author bwstx
 */
public class StorePanel extends javax.swing.JPanel {

    private final StoreService storeService;
    private List<Store> storeList;
    private Store editStore;
    private int currentStoreId;
    private int currentEmpId;
    DefaultTableModel storeModel;

    /**
     * Creates new form StorePanel
     */
    public StorePanel() {
        initComponents();
        storeModel = (DefaultTableModel) tblStore.getModel();
        UIManager.put("OptionPane.messageFont", new Font("Tahoma", Font.BOLD, 14));
        storeService = new StoreService();
        currentStoreId = storeService.getLast().getStoreId() + 1;
        currentEmpId = storeService.getLast().getEmpId() + 1;
        storeList = storeService.getStore();

        tblStore.setModel(new AbstractTableModel() {
            String[] columnNames = {"Store ID", "Employee ID", "Store name", "Store address", "Store Tel", "Store Tax", "Store logo"};

            @Override
            public String getColumnName(int column) {
                return columnNames[column];
            }

            @Override
            public int getRowCount() {
                return storeList.size();
            }

            @Override
            public int getColumnCount() {
                return 7;
            }

            @Override
            public Object getValueAt(int rowIndex, int columnIndex) {
                Store store = storeList.get(rowIndex);
                switch (columnIndex) {
                    case 0:
                        return store.getStoreId();
                    case 1:
                        return store.getEmpId();
                    case 2:
                        return store.getStoreName();
                    case 3:
                        return store.getStoreAddress();
                    case 4:
                        return store.getStoreTel();
                    case 5:
                        return store.getStoreTax();
                    case 6:
                        return store.getStoreLogo();
                    default:
                        return "Unknowm";
                }
            }
        });

        enableForm(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        JFC1 = new javax.swing.JFileChooser();
        scpStore = new javax.swing.JScrollPane();
        pnlStore = new javax.swing.JPanel();
        pnlImage = new javax.swing.JPanel();
        lblImg = new javax.swing.JLabel();
        lblStoreId = new javax.swing.JLabel();
        btnEditImg = new javax.swing.JButton();
        btnSave = new javax.swing.JButton();
        btnAdd = new javax.swing.JButton();
        btnClear = new javax.swing.JButton();
        btnDelete = new javax.swing.JButton();
        btnEdit = new javax.swing.JButton();
        txtStoreId = new javax.swing.JTextField();
        lblTax = new javax.swing.JLabel();
        txtTax = new javax.swing.JTextField();
        lblEmpId = new javax.swing.JLabel();
        txtEmpId = new javax.swing.JTextField();
        lblName = new javax.swing.JLabel();
        txtName = new javax.swing.JTextField();
        lblTel = new javax.swing.JLabel();
        txtTel = new javax.swing.JTextField();
        lblAddress = new javax.swing.JLabel();
        scpAddress = new javax.swing.JScrollPane();
        txtAddress = new javax.swing.JTextArea();
        scpTblStore = new javax.swing.JScrollPane();
        tblStore = new javax.swing.JTable();
        btnDelImg = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();

        pnlStore.setBackground(new java.awt.Color(245, 245, 245));
        pnlStore.setMinimumSize(new java.awt.Dimension(16, 16));

        pnlImage.setBackground(new java.awt.Color(255, 255, 255));

        lblImg.setText("Image");

        javax.swing.GroupLayout pnlImageLayout = new javax.swing.GroupLayout(pnlImage);
        pnlImage.setLayout(pnlImageLayout);
        pnlImageLayout.setHorizontalGroup(
            pnlImageLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlImageLayout.createSequentialGroup()
                .addGap(43, 43, 43)
                .addComponent(lblImg)
                .addContainerGap(46, Short.MAX_VALUE))
        );
        pnlImageLayout.setVerticalGroup(
            pnlImageLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlImageLayout.createSequentialGroup()
                .addGap(52, 52, 52)
                .addComponent(lblImg)
                .addContainerGap(53, Short.MAX_VALUE))
        );

        lblStoreId.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        lblStoreId.setText("รหัสสาขา :");

        btnEditImg.setBackground(new java.awt.Color(172, 145, 118));
        btnEditImg.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        btnEditImg.setText("แนบ");
        btnEditImg.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnEditImg.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnEditImgActionPerformed(evt);
            }
        });

        btnSave.setBackground(new java.awt.Color(172, 145, 118));
        btnSave.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        btnSave.setText("บันทึก");
        btnSave.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveActionPerformed(evt);
            }
        });

        btnAdd.setBackground(new java.awt.Color(172, 145, 118));
        btnAdd.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        btnAdd.setText("เพิ่มข้อมูล");
        btnAdd.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddActionPerformed(evt);
            }
        });

        btnClear.setBackground(new java.awt.Color(172, 145, 118));
        btnClear.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        btnClear.setText("ยกเลิก");
        btnClear.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnClearActionPerformed(evt);
            }
        });

        btnDelete.setBackground(new java.awt.Color(172, 145, 118));
        btnDelete.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        btnDelete.setText("ลบข้อมูล");
        btnDelete.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDeleteActionPerformed(evt);
            }
        });

        btnEdit.setBackground(new java.awt.Color(172, 145, 118));
        btnEdit.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        btnEdit.setText("แก้ไข");
        btnEdit.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnEdit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnEditActionPerformed(evt);
            }
        });

        txtStoreId.setEditable(false);
        txtStoreId.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        txtStoreId.setFocusable(false);
        txtStoreId.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtStoreIdActionPerformed(evt);
            }
        });

        lblTax.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        lblTax.setText("หมายเลขภาษี :");

        txtTax.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N

        lblEmpId.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        lblEmpId.setText("รหัสพนักงาน :");

        txtEmpId.setEditable(false);
        txtEmpId.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N

        lblName.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        lblName.setText("ชื่อสาขา :");

        txtName.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        txtName.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtNameActionPerformed(evt);
            }
        });

        lblTel.setBackground(new java.awt.Color(0, 0, 0));
        lblTel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        lblTel.setText("เบอร์โทรศัพท์ :");

        txtTel.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N

        lblAddress.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        lblAddress.setText("ที่อยู่ :");

        txtAddress.setColumns(20);
        txtAddress.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        txtAddress.setRows(5);
        txtAddress.setBorder(null);
        scpAddress.setViewportView(txtAddress);

        scpTblStore.setAutoscrolls(true);

        tblStore.setBackground(new java.awt.Color(211, 197, 186));
        tblStore.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        tblStore.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4", "Title 5", "Title 6", "Title 7"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.Integer.class, java.lang.String.class, java.lang.String.class, java.lang.Object.class, java.lang.Integer.class, java.lang.String.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        tblStore.setGridColor(new java.awt.Color(255, 255, 255));
        tblStore.setRowHeight(40);
        tblStore.setSelectionBackground(new java.awt.Color(172, 145, 118));
        tblStore.setShowGrid(true);
        scpTblStore.setViewportView(tblStore);
        if (tblStore.getColumnModel().getColumnCount() > 0) {
            tblStore.getColumnModel().getColumn(0).setResizable(false);
            tblStore.getColumnModel().getColumn(0).setPreferredWidth(50);
            tblStore.getColumnModel().getColumn(1).setResizable(false);
            tblStore.getColumnModel().getColumn(1).setPreferredWidth(50);
            tblStore.getColumnModel().getColumn(2).setResizable(false);
            tblStore.getColumnModel().getColumn(2).setPreferredWidth(250);
            tblStore.getColumnModel().getColumn(3).setResizable(false);
            tblStore.getColumnModel().getColumn(4).setResizable(false);
            tblStore.getColumnModel().getColumn(5).setResizable(false);
            tblStore.getColumnModel().getColumn(6).setResizable(false);
        }

        btnDelImg.setBackground(new java.awt.Color(172, 145, 118));
        btnDelImg.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        btnDelImg.setText("ลบรูปภาพ");
        btnDelImg.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnDelImg.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDelImgActionPerformed(evt);
            }
        });

        jButton1.setBackground(new java.awt.Color(172, 145, 118));
        jButton1.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jButton1.setText("พิมพ์");
        jButton1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout pnlStoreLayout = new javax.swing.GroupLayout(pnlStore);
        pnlStore.setLayout(pnlStoreLayout);
        pnlStoreLayout.setHorizontalGroup(
            pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlStoreLayout.createSequentialGroup()
                .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(pnlStoreLayout.createSequentialGroup()
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(btnAdd)
                        .addGap(30, 30, 30)
                        .addComponent(btnEdit, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(30, 30, 30)
                        .addComponent(btnDelete)
                        .addGap(30, 30, 30)
                        .addComponent(jButton1))
                    .addGroup(pnlStoreLayout.createSequentialGroup()
                        .addGap(28, 28, 28)
                        .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(scpTblStore)
                            .addGroup(pnlStoreLayout.createSequentialGroup()
                                .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(lblStoreId, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(lblEmpId, javax.swing.GroupLayout.DEFAULT_SIZE, 124, Short.MAX_VALUE)
                                    .addComponent(lblAddress, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                        .addComponent(txtStoreId, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)
                                        .addComponent(txtEmpId))
                                    .addComponent(scpAddress, javax.swing.GroupLayout.PREFERRED_SIZE, 295, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 110, Short.MAX_VALUE)
                                .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlStoreLayout.createSequentialGroup()
                                        .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                            .addComponent(lblTax, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                            .addComponent(lblName, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                            .addComponent(lblTel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addGap(18, 18, 18)
                                        .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                            .addComponent(txtName)
                                            .addComponent(txtTax)
                                            .addComponent(txtTel, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlStoreLayout.createSequentialGroup()
                                        .addComponent(btnSave)
                                        .addGap(18, 18, 18)
                                        .addComponent(btnClear)))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 50, Short.MAX_VALUE)
                                .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlStoreLayout.createSequentialGroup()
                                        .addComponent(btnEditImg, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(btnDelImg))
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlStoreLayout.createSequentialGroup()
                                        .addComponent(pnlImage, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(38, 38, 38)))))))
                .addGap(30, 30, 30))
        );
        pnlStoreLayout.setVerticalGroup(
            pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlStoreLayout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlStoreLayout.createSequentialGroup()
                        .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblStoreId)
                            .addComponent(txtStoreId, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(26, 26, 26)
                        .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblEmpId)
                            .addComponent(txtEmpId, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(28, 28, 28)
                        .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblAddress)
                            .addComponent(scpAddress, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(pnlStoreLayout.createSequentialGroup()
                        .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(pnlStoreLayout.createSequentialGroup()
                                .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(lblTax)
                                    .addComponent(txtTax, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(26, 26, 26)
                                .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(lblName)
                                    .addComponent(txtName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(26, 26, 26)
                                .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(txtTel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(lblTel)))
                            .addComponent(pnlImage, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(46, 46, 46)
                        .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(btnClear, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(btnSave, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(btnDelImg, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(btnEditImg, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(18, 18, 18)
                .addComponent(scpTblStore, javax.swing.GroupLayout.DEFAULT_SIZE, 261, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(pnlStoreLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(btnEdit, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(btnDelete, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(btnAdd, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(7, Short.MAX_VALUE))
        );

        scpStore.setViewportView(pnlStore);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(scpStore)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(scpStore)
        );
    }// </editor-fold>//GEN-END:initComponents

    public void setEditedStore() {
        editStore.setEmpId(currentEmpId);
        editStore.setStoreAddress(txtAddress.getText());
        editStore.setStoreId(currentStoreId);
        editStore.setStoreLogo("D-coffee.jpg");
        editStore.setStoreName(txtName.getText());
        editStore.setStoreTax(Integer.parseInt(txtTax.getText()));
        editStore.setStoreTel(txtTel.getText());
    }

    public void refreashTableUsingDefaultModel() {
        storeModel.setRowCount(0);
        storeList = storeService.getStore();
        for (Store s : storeList) {
            storeModel.addRow(new Object[]{s.getStoreId(), s.getEmpId(), s.getStoreName(), s.getStoreAddress(), s.getStoreTel(), s.getStoreTax(), s.getStoreLogo()});
        }
    }

    private void setObjectToForm() {
        txtStoreId.setText(Integer.toString(editStore.getStoreId()));
        txtEmpId.setText(Integer.toString(editStore.getEmpId()));
        txtName.setText(editStore.getStoreName());
        txtAddress.setText(editStore.getStoreAddress());
        txtTel.setText(editStore.getStoreTel());
        txtTax.setText(Integer.toString(editStore.getStoreTax()));
    }

    private void btnAddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddActionPerformed

        editStore = new Store();
        setObjectToForm();
        enableForm(true);
        txtStoreId.setText(Integer.toString(currentStoreId));
        txtEmpId.setText(Integer.toString(currentEmpId));
    }//GEN-LAST:event_btnAddActionPerformed

    public void refreshTable() {
        storeList = storeService.getStore();
        tblStore.revalidate();
        tblStore.repaint();
    }
    private void btnDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDeleteActionPerformed
        int selectedIndex = tblStore.getSelectedRow();
        if (selectedIndex >= 0) {
            editStore = storeList.get(selectedIndex);
            int deleteConfirm = JOptionPane.showConfirmDialog(this, "Delete the selected data row ?", "Confirm deletion", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
            if (deleteConfirm == 0) {
                storeService.delete(editStore);
                editStore = new Store();
                refreashTableUsingDefaultModel();
                refreshTable();
            }
        }
    }//GEN-LAST:event_btnDeleteActionPerformed

    private void btnEditActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnEditActionPerformed
        int selectedRow = tblStore.getSelectedRow();
        if (selectedRow >= 0) {
            txtAddress.setText(storeList.get(selectedRow).getStoreAddress());
            txtEmpId.setText(Integer.toString(storeList.get(selectedRow).getEmpId()));
            txtName.setText(storeList.get(selectedRow).getStoreName());
            txtStoreId.setText(Integer.toString(storeList.get(selectedRow).getStoreId()));
            txtTax.setText(Integer.toString(storeList.get(selectedRow).getStoreTax()));
            txtTel.setText(storeList.get(selectedRow).getStoreTel());
            editStore = storeList.get(selectedRow);
        }
//        editStore = new Store();
//        setObjectToForm();
        enableForm(true);
    }//GEN-LAST:event_btnEditActionPerformed

    private void btnSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveActionPerformed
        int selectedIndex = tblStore.getSelectedRow();
        if (!txtStoreId.getText().isBlank() && !txtEmpId.getText().isBlank() && !txtName.getText().isBlank() && !txtTax.getText().isBlank() && !txtTel.getText().isBlank()
                && !txtAddress.getText().isBlank()) {
            if (storeService.getStoreByid(Integer.parseInt(txtStoreId.getText())) != null) {
                int save = JOptionPane.showConfirmDialog(null, "มีข้อมูลอยู่แล้ว ต้องการแทนที่หรือไม่", "แจ้งเตือน", JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE);
                if (save == 0) {
                    setFormToObject();

                    storeService.update(editStore);
                    JOptionPane.showMessageDialog(this, "เพิ่มข้อมูลสำเร็จ", "แจ้งเตือน", JOptionPane.INFORMATION_MESSAGE);
                    refreashTableUsingDefaultModel();
                    refreshTable();
                    enableForm(false);
                } else {
                    return;
                }
            } else {
                int newsave = JOptionPane.showConfirmDialog(null, "ข้อมูลนี้ไม่มีอยู่ ต้องการเพิ่มหรือไม่", "แจ้งเตือน", JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE);
                if (newsave == 0) {
                    setEditedStore();
                    storeService.add(editStore);
                    JOptionPane.showMessageDialog(this, "เพิ่มข้อมูลสำเร็จ", "แจ้งเตือน", JOptionPane.INFORMATION_MESSAGE);
                    refreashTableUsingDefaultModel();
                    refreshTable();
                    enableForm(false);
                } else {
                    return;
                }
            }
        } else if (!txtStoreId.getText().isBlank() || !txtEmpId.getText().isBlank() || !txtName.getText().isBlank() || !txtTax.getText().isBlank() || !txtTel.getText().isBlank()
                || !txtAddress.getText().isBlank()) {
            JOptionPane.showMessageDialog(null, "ข้อมูลไม่ถูกต้อง กรุณากรอกให้ครบถ้วน", "ข้อมูลไม่ถูกต้อง", JOptionPane.INFORMATION_MESSAGE);
        }

    }//GEN-LAST:event_btnSaveActionPerformed

    private void btnEditImgActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnEditImgActionPerformed
        if (JFC1.showOpenDialog(btnEditImg) == JFileChooser.APPROVE_OPTION) {
            java.io.File f = JFC1.getSelectedFile();
            ImageIcon img = new ImageIcon(f.toString());
            Image scaleimage = img.getImage().getScaledInstance(114, 142, Image.SCALE_DEFAULT);
            img = new ImageIcon(scaleimage);
            //img.paintIcon(JFC1, null, 20, 20);
            lblImg.setIcon(img);
            lblImg.setText("");
        }
    }//GEN-LAST:event_btnEditImgActionPerformed

    private void btnClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnClearActionPerformed
        editStore = new Store();
        setObjectToForm();
        enableForm(true);
    }//GEN-LAST:event_btnClearActionPerformed

    private void btnDelImgActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDelImgActionPerformed
        if (lblImg.getText().equals("Image")) {
            return;
        } else {
            int result = JOptionPane.showConfirmDialog(null, "ต้องการที่จะลบรูปภาพหรือไม่", "ลบรูปภาพ", JOptionPane.OK_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE);
            if (result == JOptionPane.OK_OPTION) {
                lblImg.setIcon(null);
                lblImg.setText("Image");
            }
        }
    }//GEN-LAST:event_btnDelImgActionPerformed

    private void txtNameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtNameActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtNameActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (tblStore.getRowCount() > 0) {
            MessageFormat header = new MessageFormat("ข้อมูลสาขาร้าน D-Coffee");
            MessageFormat footer = new MessageFormat("หน้าที่ {0, number, integer}");

            try {
                tblStore.print(JTable.PrintMode.FIT_WIDTH, header, footer);
                storeModel.setRowCount(0);
//                setTotal();
            } catch (java.awt.print.PrinterException e) {
                JOptionPane.showMessageDialog(null, "ไม่สามารถพิมพ์รายการได้ เนื่องจากไม่พบเครื่องพิมพ์", "ไม่พบเครื่องพิมพ์", JOptionPane.INFORMATION_MESSAGE);
            }
        } else {
            JOptionPane.showMessageDialog(null, "ไม่สามารถพิมพ์รายการได้ เนื่องจากรายการยังว่างอยู่", "ไม่สามารถพิมพ์รายการได้", JOptionPane.INFORMATION_MESSAGE);
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void txtStoreIdActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtStoreIdActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtStoreIdActionPerformed

    public void setFormToObject() throws NumberFormatException {
//        System.out.println(Integer.parseInt(txtEmpId.getText()));
        editStore.setEmpId(Integer.parseInt(txtEmpId.getText()));
        editStore.setStoreName(txtName.getText());
        editStore.setStoreAddress(txtAddress.getText());
        editStore.setStoreTel(txtTel.getText());
        editStore.setStoreTax(Integer.parseInt(txtTax.getText()));
//        editStore.setMtrUnit(txtMtrUnit.getText());
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JFileChooser JFC1;
    private javax.swing.JButton btnAdd;
    private javax.swing.JButton btnClear;
    private javax.swing.JButton btnDelImg;
    private javax.swing.JButton btnDelete;
    private javax.swing.JButton btnEdit;
    private javax.swing.JButton btnEditImg;
    private javax.swing.JButton btnSave;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel lblAddress;
    private javax.swing.JLabel lblEmpId;
    private javax.swing.JLabel lblImg;
    private javax.swing.JLabel lblName;
    private javax.swing.JLabel lblStoreId;
    private javax.swing.JLabel lblTax;
    private javax.swing.JLabel lblTel;
    private javax.swing.JPanel pnlImage;
    private javax.swing.JPanel pnlStore;
    private javax.swing.JScrollPane scpAddress;
    private javax.swing.JScrollPane scpStore;
    private javax.swing.JScrollPane scpTblStore;
    private javax.swing.JTable tblStore;
    private javax.swing.JTextArea txtAddress;
    private javax.swing.JTextField txtEmpId;
    private javax.swing.JTextField txtName;
    private javax.swing.JTextField txtStoreId;
    private javax.swing.JTextField txtTax;
    private javax.swing.JTextField txtTel;
    // End of variables declaration//GEN-END:variables

    private void enableForm(boolean bool) {
        if (bool == false) {
            txtStoreId.setText("");
            txtEmpId.setText("");
            txtName.setText("");
            txtAddress.setText("");
            txtTel.setText("");
            txtTax.setText("");
        }
        //txtStoreId.setEnabled(bool);
        txtEmpId.setEnabled(bool);
        txtName.setEnabled(bool);
        txtAddress.setEnabled(bool);
        txtTel.setEnabled(bool);
        txtTax.setEnabled(bool);
        btnSave.setEnabled(bool);
        btnClear.setEnabled(bool);
//        if (bool == true) {
//            txtStoreId.requestFocus();
//        }
    }
}
